/*
   bin.c:
   Source file to create bin.dll
   Assembly Studio plug-in to output a binary file

   Copyright (c) 2001 Ti-Calculator Programming Alliance
   Programmed by James Vernon <james@calc.org>
   http://tcpa.calc.org
   ICQ#: 71589304
*/

#include <stdio.h>
#include <string.h>

/* note that windows routines are used only for the About command */
#include <windows.h>
#include <winuser.h>

__declspec(dllexport) const char *GetPluginDescription()
{
	return("Binary File");
}

__declspec(dllexport) void About()
{
    MessageBox( NULL,
        "Binary File export\n"
        "Assembly Studio plugin\n"
        "Copyright (c)2001 Ti-Calculator Programming Alliance\n"
        "Programmed by James Vernon\n"
        "james@calc.org <> http://tcpa.calc.org <> ICQ#: 71589304",
        "About bin.dll", MB_OK);
}

__declspec(dllexport) int SavePrgmFile(unsigned char *pData, unsigned nLength, const char *szFilename, char *szExt)
{
	FILE *out;
	unsigned checksum = 0;
	char pbuff[128];

	/* add extension to filename and open file */
	strcpy(pbuff, szFilename);
	strcat(pbuff, ".bin");
	if ((out = fopen(pbuff, "wb")) == NULL)
		return(0);

    /* write binary data to output file */
    fwrite(pData, 1, nLength, out);

	/* return given extension */
	if (szExt != NULL)
		strcpy(szExt, ".bin");
	return(1);
}